// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dataspeed_can_msgs:msg/Frame.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_CAN_MSGS__MSG__DETAIL__FRAME__STRUCT_H_
#define DATASPEED_CAN_MSGS__MSG__DETAIL__FRAME__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'data'
#include "rosidl_runtime_c/primitives_sequence.h"

// constants for array fields with an upper bound
// data
enum
{
  dataspeed_can_msgs__msg__Frame__data__MAX_SIZE = 64
};

/// Struct defined in msg/Frame in the package dataspeed_can_msgs.
/**
  * Extension of can_msgs/Frame to support CAN-FD flags and larger data sizes
 */
typedef struct dataspeed_can_msgs__msg__Frame
{
  std_msgs__msg__Header header;
  uint32_t id;
  bool extended;
  bool fdf;
  bool brs;
  bool esi;
  bool rtr;
  rosidl_runtime_c__uint8__Sequence data;
} dataspeed_can_msgs__msg__Frame;

// Struct for a sequence of dataspeed_can_msgs__msg__Frame.
typedef struct dataspeed_can_msgs__msg__Frame__Sequence
{
  dataspeed_can_msgs__msg__Frame * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dataspeed_can_msgs__msg__Frame__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_CAN_MSGS__MSG__DETAIL__FRAME__STRUCT_H_
