// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_autonomy_msgs:srv/LoadNetwork.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__LOAD_NETWORK__STRUCT_H_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__LOAD_NETWORK__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'drn_data'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in srv/LoadNetwork in the package ds_autonomy_msgs.
typedef struct ds_autonomy_msgs__srv__LoadNetwork_Request
{
  rosidl_runtime_c__uint8__Sequence drn_data;
} ds_autonomy_msgs__srv__LoadNetwork_Request;

// Struct for a sequence of ds_autonomy_msgs__srv__LoadNetwork_Request.
typedef struct ds_autonomy_msgs__srv__LoadNetwork_Request__Sequence
{
  ds_autonomy_msgs__srv__LoadNetwork_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_autonomy_msgs__srv__LoadNetwork_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'latlon_points'
#include "ds_autonomy_msgs/msg/detail/lat_lon_point__struct.h"
// Member 'cartesian_points'
#include "geometry_msgs/msg/detail/point__struct.h"

/// Struct defined in srv/LoadNetwork in the package ds_autonomy_msgs.
typedef struct ds_autonomy_msgs__srv__LoadNetwork_Response
{
  ds_autonomy_msgs__msg__LatLonPoint__Sequence latlon_points;
  geometry_msgs__msg__Point__Sequence cartesian_points;
  bool success;
} ds_autonomy_msgs__srv__LoadNetwork_Response;

// Struct for a sequence of ds_autonomy_msgs__srv__LoadNetwork_Response.
typedef struct ds_autonomy_msgs__srv__LoadNetwork_Response__Sequence
{
  ds_autonomy_msgs__srv__LoadNetwork_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_autonomy_msgs__srv__LoadNetwork_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  ds_autonomy_msgs__srv__LoadNetwork_Event__request__MAX_SIZE = 1
};
// response
enum
{
  ds_autonomy_msgs__srv__LoadNetwork_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/LoadNetwork in the package ds_autonomy_msgs.
typedef struct ds_autonomy_msgs__srv__LoadNetwork_Event
{
  service_msgs__msg__ServiceEventInfo info;
  ds_autonomy_msgs__srv__LoadNetwork_Request__Sequence request;
  ds_autonomy_msgs__srv__LoadNetwork_Response__Sequence response;
} ds_autonomy_msgs__srv__LoadNetwork_Event;

// Struct for a sequence of ds_autonomy_msgs__srv__LoadNetwork_Event.
typedef struct ds_autonomy_msgs__srv__LoadNetwork_Event__Sequence
{
  ds_autonomy_msgs__srv__LoadNetwork_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_autonomy_msgs__srv__LoadNetwork_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__LOAD_NETWORK__STRUCT_H_
