// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from ds_autonomy_msgs:srv/SetSpeedConstraints.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__BUILDER_HPP_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "ds_autonomy_msgs/srv/detail/set_speed_constraints__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace ds_autonomy_msgs
{

namespace srv
{

namespace builder
{

class Init_SetSpeedConstraints_Request_jerk_limit
{
public:
  explicit Init_SetSpeedConstraints_Request_jerk_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg)
  : msg_(msg)
  {}
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Request jerk_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request::_jerk_limit_type arg)
  {
    msg_.jerk_limit = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Request msg_;
};

class Init_SetSpeedConstraints_Request_linear_decel
{
public:
  explicit Init_SetSpeedConstraints_Request_linear_decel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg)
  : msg_(msg)
  {}
  Init_SetSpeedConstraints_Request_jerk_limit linear_decel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request::_linear_decel_type arg)
  {
    msg_.linear_decel = std::move(arg);
    return Init_SetSpeedConstraints_Request_jerk_limit(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Request msg_;
};

class Init_SetSpeedConstraints_Request_linear_accel
{
public:
  explicit Init_SetSpeedConstraints_Request_linear_accel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg)
  : msg_(msg)
  {}
  Init_SetSpeedConstraints_Request_linear_decel linear_accel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request::_linear_accel_type arg)
  {
    msg_.linear_accel = std::move(arg);
    return Init_SetSpeedConstraints_Request_linear_decel(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Request msg_;
};

class Init_SetSpeedConstraints_Request_lateral_accel_limit
{
public:
  explicit Init_SetSpeedConstraints_Request_lateral_accel_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg)
  : msg_(msg)
  {}
  Init_SetSpeedConstraints_Request_linear_accel lateral_accel_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request::_lateral_accel_limit_type arg)
  {
    msg_.lateral_accel_limit = std::move(arg);
    return Init_SetSpeedConstraints_Request_linear_accel(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Request msg_;
};

class Init_SetSpeedConstraints_Request_speed_limit
{
public:
  Init_SetSpeedConstraints_Request_speed_limit()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SetSpeedConstraints_Request_lateral_accel_limit speed_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Request::_speed_limit_type arg)
  {
    msg_.speed_limit = std::move(arg);
    return Init_SetSpeedConstraints_Request_lateral_accel_limit(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_autonomy_msgs::srv::SetSpeedConstraints_Request>()
{
  return ds_autonomy_msgs::srv::builder::Init_SetSpeedConstraints_Request_speed_limit();
}

}  // namespace ds_autonomy_msgs


namespace ds_autonomy_msgs
{

namespace srv
{

namespace builder
{

class Init_SetSpeedConstraints_Response_actual_jerk_limit
{
public:
  explicit Init_SetSpeedConstraints_Response_actual_jerk_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg)
  : msg_(msg)
  {}
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Response actual_jerk_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response::_actual_jerk_limit_type arg)
  {
    msg_.actual_jerk_limit = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Response msg_;
};

class Init_SetSpeedConstraints_Response_actual_linear_decel
{
public:
  explicit Init_SetSpeedConstraints_Response_actual_linear_decel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg)
  : msg_(msg)
  {}
  Init_SetSpeedConstraints_Response_actual_jerk_limit actual_linear_decel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response::_actual_linear_decel_type arg)
  {
    msg_.actual_linear_decel = std::move(arg);
    return Init_SetSpeedConstraints_Response_actual_jerk_limit(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Response msg_;
};

class Init_SetSpeedConstraints_Response_actual_linear_accel
{
public:
  explicit Init_SetSpeedConstraints_Response_actual_linear_accel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg)
  : msg_(msg)
  {}
  Init_SetSpeedConstraints_Response_actual_linear_decel actual_linear_accel(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response::_actual_linear_accel_type arg)
  {
    msg_.actual_linear_accel = std::move(arg);
    return Init_SetSpeedConstraints_Response_actual_linear_decel(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Response msg_;
};

class Init_SetSpeedConstraints_Response_actual_lateral_accel_limit
{
public:
  explicit Init_SetSpeedConstraints_Response_actual_lateral_accel_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg)
  : msg_(msg)
  {}
  Init_SetSpeedConstraints_Response_actual_linear_accel actual_lateral_accel_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response::_actual_lateral_accel_limit_type arg)
  {
    msg_.actual_lateral_accel_limit = std::move(arg);
    return Init_SetSpeedConstraints_Response_actual_linear_accel(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Response msg_;
};

class Init_SetSpeedConstraints_Response_actual_speed_limit
{
public:
  Init_SetSpeedConstraints_Response_actual_speed_limit()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SetSpeedConstraints_Response_actual_lateral_accel_limit actual_speed_limit(::ds_autonomy_msgs::srv::SetSpeedConstraints_Response::_actual_speed_limit_type arg)
  {
    msg_.actual_speed_limit = std::move(arg);
    return Init_SetSpeedConstraints_Response_actual_lateral_accel_limit(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_autonomy_msgs::srv::SetSpeedConstraints_Response>()
{
  return ds_autonomy_msgs::srv::builder::Init_SetSpeedConstraints_Response_actual_speed_limit();
}

}  // namespace ds_autonomy_msgs


namespace ds_autonomy_msgs
{

namespace srv
{

namespace builder
{

class Init_SetSpeedConstraints_Event_response
{
public:
  explicit Init_SetSpeedConstraints_Event_response(::ds_autonomy_msgs::srv::SetSpeedConstraints_Event & msg)
  : msg_(msg)
  {}
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Event response(::ds_autonomy_msgs::srv::SetSpeedConstraints_Event::_response_type arg)
  {
    msg_.response = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Event msg_;
};

class Init_SetSpeedConstraints_Event_request
{
public:
  explicit Init_SetSpeedConstraints_Event_request(::ds_autonomy_msgs::srv::SetSpeedConstraints_Event & msg)
  : msg_(msg)
  {}
  Init_SetSpeedConstraints_Event_response request(::ds_autonomy_msgs::srv::SetSpeedConstraints_Event::_request_type arg)
  {
    msg_.request = std::move(arg);
    return Init_SetSpeedConstraints_Event_response(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Event msg_;
};

class Init_SetSpeedConstraints_Event_info
{
public:
  Init_SetSpeedConstraints_Event_info()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SetSpeedConstraints_Event_request info(::ds_autonomy_msgs::srv::SetSpeedConstraints_Event::_info_type arg)
  {
    msg_.info = std::move(arg);
    return Init_SetSpeedConstraints_Event_request(msg_);
  }

private:
  ::ds_autonomy_msgs::srv::SetSpeedConstraints_Event msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_autonomy_msgs::srv::SetSpeedConstraints_Event>()
{
  return ds_autonomy_msgs::srv::builder::Init_SetSpeedConstraints_Event_info();
}

}  // namespace ds_autonomy_msgs

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__BUILDER_HPP_
