// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_autonomy_msgs:srv/SetSpeedConstraints.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__TRAITS_HPP_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_autonomy_msgs/srv/detail/set_speed_constraints__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace ds_autonomy_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetSpeedConstraints_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: speed_limit
  {
    out << "speed_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_limit, out);
    out << ", ";
  }

  // member: lateral_accel_limit
  {
    out << "lateral_accel_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_accel_limit, out);
    out << ", ";
  }

  // member: linear_accel
  {
    out << "linear_accel: ";
    rosidl_generator_traits::value_to_yaml(msg.linear_accel, out);
    out << ", ";
  }

  // member: linear_decel
  {
    out << "linear_decel: ";
    rosidl_generator_traits::value_to_yaml(msg.linear_decel, out);
    out << ", ";
  }

  // member: jerk_limit
  {
    out << "jerk_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.jerk_limit, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetSpeedConstraints_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: speed_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_limit, out);
    out << "\n";
  }

  // member: lateral_accel_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_accel_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_accel_limit, out);
    out << "\n";
  }

  // member: linear_accel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_accel: ";
    rosidl_generator_traits::value_to_yaml(msg.linear_accel, out);
    out << "\n";
  }

  // member: linear_decel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_decel: ";
    rosidl_generator_traits::value_to_yaml(msg.linear_decel, out);
    out << "\n";
  }

  // member: jerk_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "jerk_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.jerk_limit, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetSpeedConstraints_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_autonomy_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_autonomy_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_autonomy_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg)
{
  return ds_autonomy_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>()
{
  return "ds_autonomy_msgs::srv::SetSpeedConstraints_Request";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>()
{
  return "ds_autonomy_msgs/srv/SetSpeedConstraints_Request";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace ds_autonomy_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetSpeedConstraints_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: actual_speed_limit
  {
    out << "actual_speed_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_speed_limit, out);
    out << ", ";
  }

  // member: actual_lateral_accel_limit
  {
    out << "actual_lateral_accel_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_lateral_accel_limit, out);
    out << ", ";
  }

  // member: actual_linear_accel
  {
    out << "actual_linear_accel: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_linear_accel, out);
    out << ", ";
  }

  // member: actual_linear_decel
  {
    out << "actual_linear_decel: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_linear_decel, out);
    out << ", ";
  }

  // member: actual_jerk_limit
  {
    out << "actual_jerk_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_jerk_limit, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetSpeedConstraints_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: actual_speed_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_speed_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_speed_limit, out);
    out << "\n";
  }

  // member: actual_lateral_accel_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_lateral_accel_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_lateral_accel_limit, out);
    out << "\n";
  }

  // member: actual_linear_accel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_linear_accel: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_linear_accel, out);
    out << "\n";
  }

  // member: actual_linear_decel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_linear_decel: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_linear_decel, out);
    out << "\n";
  }

  // member: actual_jerk_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_jerk_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.actual_jerk_limit, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetSpeedConstraints_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_autonomy_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_autonomy_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_autonomy_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg)
{
  return ds_autonomy_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>()
{
  return "ds_autonomy_msgs::srv::SetSpeedConstraints_Response";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>()
{
  return "ds_autonomy_msgs/srv/SetSpeedConstraints_Response";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace ds_autonomy_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetSpeedConstraints_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetSpeedConstraints_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetSpeedConstraints_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_autonomy_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_autonomy_msgs::srv::SetSpeedConstraints_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_autonomy_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_autonomy_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const ds_autonomy_msgs::srv::SetSpeedConstraints_Event & msg)
{
  return ds_autonomy_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetSpeedConstraints_Event>()
{
  return "ds_autonomy_msgs::srv::SetSpeedConstraints_Event";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetSpeedConstraints_Event>()
{
  return "ds_autonomy_msgs/srv/SetSpeedConstraints_Event";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Event>
  : std::integral_constant<bool, has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>::value && has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetSpeedConstraints_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetSpeedConstraints>()
{
  return "ds_autonomy_msgs::srv::SetSpeedConstraints";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetSpeedConstraints>()
{
  return "ds_autonomy_msgs/srv/SetSpeedConstraints";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints>
  : std::integral_constant<
    bool,
    has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>::value &&
    has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>::value
  >
{
};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints>
  : std::integral_constant<
    bool,
    has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>::value &&
    has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>::value
  >
{
};

template<>
struct is_service<ds_autonomy_msgs::srv::SetSpeedConstraints>
  : std::true_type
{
};

template<>
struct is_service_request<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::true_type
{
};

template<>
struct is_service_response<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__TRAITS_HPP_
