// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/BatteryTraction.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__BATTERY_TRACTION__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__BATTERY_TRACTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'STATUS_UNKNOWN'.
enum
{
  ds_dbw_msgs__msg__BatteryTraction__STATUS_UNKNOWN = 0
};

/// Constant 'STATUS_NOT_CHARGING'.
enum
{
  ds_dbw_msgs__msg__BatteryTraction__STATUS_NOT_CHARGING = 1
};

/// Constant 'STATUS_CHARGING'.
enum
{
  ds_dbw_msgs__msg__BatteryTraction__STATUS_CHARGING = 2
};

/// Constant 'STATUS_COMPLETE'.
enum
{
  ds_dbw_msgs__msg__BatteryTraction__STATUS_COMPLETE = 3
};

/// Constant 'STATUS_FAULT'.
enum
{
  ds_dbw_msgs__msg__BatteryTraction__STATUS_FAULT = 7
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/BatteryTraction in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__BatteryTraction
{
  std_msgs__msg__Header header;
  /// High voltage traction battery
  /// %
  float state_of_charge;
  /// V
  float voltage;
  /// A
  float current;
  /// deg C
  float temperature;
  /// Charge status
  uint8_t status;
} ds_dbw_msgs__msg__BatteryTraction;

// Struct for a sequence of ds_dbw_msgs__msg__BatteryTraction.
typedef struct ds_dbw_msgs__msg__BatteryTraction__Sequence
{
  ds_dbw_msgs__msg__BatteryTraction * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__BatteryTraction__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__BATTERY_TRACTION__STRUCT_H_
