// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/BrakeInfo.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__BRAKE_INFO__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__BRAKE_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'brake_pedal_qf'
#include "ds_dbw_msgs/msg/detail/quality__struct.h"

/// Struct defined in msg/BrakeInfo in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__BrakeInfo
{
  std_msgs__msg__Header header;
  /// Brake Pedal
  /// Nm
  float brake_torque_pedal;
  /// Nm
  float brake_torque_request;
  /// Nm
  float brake_torque_actual;
  ds_dbw_msgs__msg__Quality brake_pedal_qf;
  /// Brake vacuum pressure
  /// bar
  float brake_vacuum;
  /// Anti-lock Brakes
  bool abs_active;
  bool abs_enabled;
  /// Stability Control
  bool esc_active;
  bool esc_enabled;
  /// Traction Control
  bool trac_active;
  bool trac_enabled;
} ds_dbw_msgs__msg__BrakeInfo;

// Struct for a sequence of ds_dbw_msgs__msg__BrakeInfo.
typedef struct ds_dbw_msgs__msg__BrakeInfo__Sequence
{
  ds_dbw_msgs__msg__BrakeInfo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__BrakeInfo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__BRAKE_INFO__STRUCT_H_
