// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from ds_dbw_msgs:msg/HeadlightCtrlLow.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__HEADLIGHT_CTRL_LOW__FUNCTIONS_H_
#define DS_DBW_MSGS__MSG__DETAIL__HEADLIGHT_CTRL_LOW__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "ds_dbw_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "ds_dbw_msgs/msg/detail/headlight_ctrl_low__struct.h"

/// Initialize msg/HeadlightCtrlLow message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * ds_dbw_msgs__msg__HeadlightCtrlLow
 * )) before or use
 * ds_dbw_msgs__msg__HeadlightCtrlLow__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
bool
ds_dbw_msgs__msg__HeadlightCtrlLow__init(ds_dbw_msgs__msg__HeadlightCtrlLow * msg);

/// Finalize msg/HeadlightCtrlLow message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
void
ds_dbw_msgs__msg__HeadlightCtrlLow__fini(ds_dbw_msgs__msg__HeadlightCtrlLow * msg);

/// Create msg/HeadlightCtrlLow message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * ds_dbw_msgs__msg__HeadlightCtrlLow__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
ds_dbw_msgs__msg__HeadlightCtrlLow *
ds_dbw_msgs__msg__HeadlightCtrlLow__create();

/// Destroy msg/HeadlightCtrlLow message.
/**
 * It calls
 * ds_dbw_msgs__msg__HeadlightCtrlLow__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
void
ds_dbw_msgs__msg__HeadlightCtrlLow__destroy(ds_dbw_msgs__msg__HeadlightCtrlLow * msg);

/// Check for msg/HeadlightCtrlLow message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
bool
ds_dbw_msgs__msg__HeadlightCtrlLow__are_equal(const ds_dbw_msgs__msg__HeadlightCtrlLow * lhs, const ds_dbw_msgs__msg__HeadlightCtrlLow * rhs);

/// Copy a msg/HeadlightCtrlLow message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
bool
ds_dbw_msgs__msg__HeadlightCtrlLow__copy(
  const ds_dbw_msgs__msg__HeadlightCtrlLow * input,
  ds_dbw_msgs__msg__HeadlightCtrlLow * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
const rosidl_type_hash_t *
ds_dbw_msgs__msg__HeadlightCtrlLow__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
const rosidl_runtime_c__type_description__TypeDescription *
ds_dbw_msgs__msg__HeadlightCtrlLow__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
const rosidl_runtime_c__type_description__TypeSource *
ds_dbw_msgs__msg__HeadlightCtrlLow__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
ds_dbw_msgs__msg__HeadlightCtrlLow__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/HeadlightCtrlLow messages.
/**
 * It allocates the memory for the number of elements and calls
 * ds_dbw_msgs__msg__HeadlightCtrlLow__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
bool
ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__init(ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence * array, size_t size);

/// Finalize array of msg/HeadlightCtrlLow messages.
/**
 * It calls
 * ds_dbw_msgs__msg__HeadlightCtrlLow__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
void
ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__fini(ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence * array);

/// Create array of msg/HeadlightCtrlLow messages.
/**
 * It allocates the memory for the array and calls
 * ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence *
ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__create(size_t size);

/// Destroy array of msg/HeadlightCtrlLow messages.
/**
 * It calls
 * ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
void
ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__destroy(ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence * array);

/// Check for msg/HeadlightCtrlLow message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
bool
ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__are_equal(const ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence * lhs, const ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence * rhs);

/// Copy an array of msg/HeadlightCtrlLow messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_ds_dbw_msgs
bool
ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence__copy(
  const ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence * input,
  ds_dbw_msgs__msg__HeadlightCtrlLow__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__HEADLIGHT_CTRL_LOW__FUNCTIONS_H_
