// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/SteeringDiagnostics.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__STEERING_DIAGNOSTICS__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__STEERING_DIAGNOSTICS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/SteeringDiagnostics in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__SteeringDiagnostics
{
  std_msgs__msg__Header header;
  /// Degraded
  bool degraded;
  bool degraded_cmd_type;
  bool degraded_comms;
  bool degraded_comms_dbw;
  bool degraded_comms_dbw_gateway;
  bool degraded_comms_dbw_brake;
  bool degraded_comms_dbw_thrtl;
  bool degraded_comms_dbw_gear;
  bool degraded_comms_vehicle;
  bool degraded_comms_actuator;
  bool degraded_internal;
  bool degraded_control_performance;
  bool degraded_param_mismatch;
  bool degraded_vehicle;
  bool degraded_actuator;
  bool degraded_vehicle_speed;
  bool degraded_calibration;
  /// Faults
  bool fault;
  bool fault_power;
  bool fault_comms;
  bool fault_comms_dbw;
  bool fault_comms_dbw_gateway;
  bool fault_comms_dbw_brake;
  bool fault_comms_dbw_thrtl;
  bool fault_comms_dbw_gear;
  bool fault_comms_vehicle;
  bool fault_comms_actuator;
  bool fault_internal;
  bool fault_vehicle;
  bool fault_vehicle_speed;
  bool fault_angle_sensor;
  bool fault_torque_sensor_1;
  bool fault_torque_sensor_2;
  bool fault_torque_sensor_mismatch;
  bool fault_actuator;
  bool fault_actuator_torque_sensor;
  bool fault_actuator_config;
  bool fault_actuator_assist;
  bool fault_control_performance;
  bool fault_param_mismatch;
  bool fault_param_limits;
  bool fault_calibration;
} ds_dbw_msgs__msg__SteeringDiagnostics;

// Struct for a sequence of ds_dbw_msgs__msg__SteeringDiagnostics.
typedef struct ds_dbw_msgs__msg__SteeringDiagnostics__Sequence
{
  ds_dbw_msgs__msg__SteeringDiagnostics * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__SteeringDiagnostics__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__STEERING_DIAGNOSTICS__STRUCT_H_
