// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from oxts_msgs:msg/NavSatRef.idl
// generated code does not contain a copyright notice

#ifndef OXTS_MSGS__MSG__DETAIL__NAV_SAT_REF__STRUCT_H_
#define OXTS_MSGS__MSG__DETAIL__NAV_SAT_REF__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/NavSatRef in the package oxts_msgs.
/**
  * OxTS local coordinate reference frame
 */
typedef struct oxts_msgs__msg__NavSatRef
{
  /// Standard ROS message header
  std_msgs__msg__Header header;
  /// Latitude. Positive is north of equator; negative is south.
  double latitude;
  /// Longitude. Positive is east of prime meridian; negative is west.
  double longitude;
  /// Altitude. Positive is ablve the WGS 84 ellipsoid
  double altitude;
  /// Heading. Anti-clockwise positive arounf the up axis; east is 0
  double heading;
} oxts_msgs__msg__NavSatRef;

// Struct for a sequence of oxts_msgs__msg__NavSatRef.
typedef struct oxts_msgs__msg__NavSatRef__Sequence
{
  oxts_msgs__msg__NavSatRef * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} oxts_msgs__msg__NavSatRef__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // OXTS_MSGS__MSG__DETAIL__NAV_SAT_REF__STRUCT_H_
