// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from ds_autonomy_msgs:msg/LonTarget.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "ds_autonomy_msgs/msg/detail/lon_target__functions.h"
#include "ds_autonomy_msgs/msg/detail/lon_target__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace ds_autonomy_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void LonTarget_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) ds_autonomy_msgs::msg::LonTarget(_init);
}

void LonTarget_fini_function(void * message_memory)
{
  auto typed_message = static_cast<ds_autonomy_msgs::msg::LonTarget *>(message_memory);
  typed_message->~LonTarget();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember LonTarget_message_member_array[4] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::msg::LonTarget, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "target_type",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::msg::LonTarget, target_type),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "rel_dist",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::msg::LonTarget, rel_dist),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "rel_vel",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::msg::LonTarget, rel_vel),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers LonTarget_message_members = {
  "ds_autonomy_msgs::msg",  // message namespace
  "LonTarget",  // message name
  4,  // number of fields
  sizeof(ds_autonomy_msgs::msg::LonTarget),
  LonTarget_message_member_array,  // message members
  LonTarget_init_function,  // function to initialize message memory (memory has to be allocated)
  LonTarget_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t LonTarget_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &LonTarget_message_members,
  get_message_typesupport_handle_function,
  &ds_autonomy_msgs__msg__LonTarget__get_type_hash,
  &ds_autonomy_msgs__msg__LonTarget__get_type_description,
  &ds_autonomy_msgs__msg__LonTarget__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace ds_autonomy_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<ds_autonomy_msgs::msg::LonTarget>()
{
  return &::ds_autonomy_msgs::msg::rosidl_typesupport_introspection_cpp::LonTarget_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ds_autonomy_msgs, msg, LonTarget)() {
  return &::ds_autonomy_msgs::msg::rosidl_typesupport_introspection_cpp::LonTarget_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
