// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_autonomy_msgs:srv/SetRoute.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__SET_ROUTE__STRUCT_HPP_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__SET_ROUTE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Request __attribute__((deprecated))
#else
# define DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Request __declspec(deprecated)
#endif

namespace ds_autonomy_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetRoute_Request_
{
  using Type = SetRoute_Request_<ContainerAllocator>;

  explicit SetRoute_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit SetRoute_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _node_ids_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _node_ids_type node_ids;

  // setters for named parameter idiom
  Type & set__node_ids(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->node_ids = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Request
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Request
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetRoute_Request_ & other) const
  {
    if (this->node_ids != other.node_ids) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetRoute_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetRoute_Request_

// alias to use template instance with default allocator
using SetRoute_Request =
  ds_autonomy_msgs::srv::SetRoute_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ds_autonomy_msgs


// Include directives for member types
// Member 'latlon_points'
#include "ds_autonomy_msgs/msg/detail/lat_lon_point__struct.hpp"
// Member 'cartesian_points'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Response __attribute__((deprecated))
#else
# define DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Response __declspec(deprecated)
#endif

namespace ds_autonomy_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetRoute_Response_
{
  using Type = SetRoute_Response_<ContainerAllocator>;

  explicit SetRoute_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit SetRoute_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _latlon_points_type =
    std::vector<ds_autonomy_msgs::msg::LatLonPoint_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::msg::LatLonPoint_<ContainerAllocator>>>;
  _latlon_points_type latlon_points;
  using _cartesian_points_type =
    std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point_<ContainerAllocator>>>;
  _cartesian_points_type cartesian_points;
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__latlon_points(
    const std::vector<ds_autonomy_msgs::msg::LatLonPoint_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::msg::LatLonPoint_<ContainerAllocator>>> & _arg)
  {
    this->latlon_points = _arg;
    return *this;
  }
  Type & set__cartesian_points(
    const std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point_<ContainerAllocator>>> & _arg)
  {
    this->cartesian_points = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Response
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Response
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetRoute_Response_ & other) const
  {
    if (this->latlon_points != other.latlon_points) {
      return false;
    }
    if (this->cartesian_points != other.cartesian_points) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetRoute_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetRoute_Response_

// alias to use template instance with default allocator
using SetRoute_Response =
  ds_autonomy_msgs::srv::SetRoute_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ds_autonomy_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Event __attribute__((deprecated))
#else
# define DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Event __declspec(deprecated)
#endif

namespace ds_autonomy_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetRoute_Event_
{
  using Type = SetRoute_Event_<ContainerAllocator>;

  explicit SetRoute_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit SetRoute_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetRoute_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetRoute_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Event
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetRoute_Event
    std::shared_ptr<ds_autonomy_msgs::srv::SetRoute_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetRoute_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetRoute_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetRoute_Event_

// alias to use template instance with default allocator
using SetRoute_Event =
  ds_autonomy_msgs::srv::SetRoute_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace ds_autonomy_msgs
{

namespace srv
{

struct SetRoute
{
  using Request = ds_autonomy_msgs::srv::SetRoute_Request;
  using Response = ds_autonomy_msgs::srv::SetRoute_Response;
  using Event = ds_autonomy_msgs::srv::SetRoute_Event;
};

}  // namespace srv

}  // namespace ds_autonomy_msgs

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__SET_ROUTE__STRUCT_HPP_
