// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_autonomy_msgs:srv/SetRoute.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__SET_ROUTE__TRAITS_HPP_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__SET_ROUTE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_autonomy_msgs/srv/detail/set_route__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace ds_autonomy_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetRoute_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: node_ids
  {
    if (msg.node_ids.size() == 0) {
      out << "node_ids: []";
    } else {
      out << "node_ids: [";
      size_t pending_items = msg.node_ids.size();
      for (auto item : msg.node_ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetRoute_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: node_ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.node_ids.size() == 0) {
      out << "node_ids: []\n";
    } else {
      out << "node_ids:\n";
      for (auto item : msg.node_ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetRoute_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_autonomy_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_autonomy_msgs::srv::SetRoute_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_autonomy_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_autonomy_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const ds_autonomy_msgs::srv::SetRoute_Request & msg)
{
  return ds_autonomy_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetRoute_Request>()
{
  return "ds_autonomy_msgs::srv::SetRoute_Request";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetRoute_Request>()
{
  return "ds_autonomy_msgs/srv/SetRoute_Request";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetRoute_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetRoute_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetRoute_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'latlon_points'
#include "ds_autonomy_msgs/msg/detail/lat_lon_point__traits.hpp"
// Member 'cartesian_points'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace ds_autonomy_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetRoute_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: latlon_points
  {
    if (msg.latlon_points.size() == 0) {
      out << "latlon_points: []";
    } else {
      out << "latlon_points: [";
      size_t pending_items = msg.latlon_points.size();
      for (auto item : msg.latlon_points) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: cartesian_points
  {
    if (msg.cartesian_points.size() == 0) {
      out << "cartesian_points: []";
    } else {
      out << "cartesian_points: [";
      size_t pending_items = msg.cartesian_points.size();
      for (auto item : msg.cartesian_points) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetRoute_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: latlon_points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.latlon_points.size() == 0) {
      out << "latlon_points: []\n";
    } else {
      out << "latlon_points:\n";
      for (auto item : msg.latlon_points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: cartesian_points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.cartesian_points.size() == 0) {
      out << "cartesian_points: []\n";
    } else {
      out << "cartesian_points:\n";
      for (auto item : msg.cartesian_points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetRoute_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_autonomy_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_autonomy_msgs::srv::SetRoute_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_autonomy_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_autonomy_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const ds_autonomy_msgs::srv::SetRoute_Response & msg)
{
  return ds_autonomy_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetRoute_Response>()
{
  return "ds_autonomy_msgs::srv::SetRoute_Response";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetRoute_Response>()
{
  return "ds_autonomy_msgs/srv/SetRoute_Response";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetRoute_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetRoute_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetRoute_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace ds_autonomy_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetRoute_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetRoute_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetRoute_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_autonomy_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_autonomy_msgs::srv::SetRoute_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_autonomy_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_autonomy_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const ds_autonomy_msgs::srv::SetRoute_Event & msg)
{
  return ds_autonomy_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetRoute_Event>()
{
  return "ds_autonomy_msgs::srv::SetRoute_Event";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetRoute_Event>()
{
  return "ds_autonomy_msgs/srv/SetRoute_Event";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetRoute_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetRoute_Event>
  : std::integral_constant<bool, has_bounded_size<ds_autonomy_msgs::srv::SetRoute_Request>::value && has_bounded_size<ds_autonomy_msgs::srv::SetRoute_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetRoute_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetRoute>()
{
  return "ds_autonomy_msgs::srv::SetRoute";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetRoute>()
{
  return "ds_autonomy_msgs/srv/SetRoute";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetRoute>
  : std::integral_constant<
    bool,
    has_fixed_size<ds_autonomy_msgs::srv::SetRoute_Request>::value &&
    has_fixed_size<ds_autonomy_msgs::srv::SetRoute_Response>::value
  >
{
};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetRoute>
  : std::integral_constant<
    bool,
    has_bounded_size<ds_autonomy_msgs::srv::SetRoute_Request>::value &&
    has_bounded_size<ds_autonomy_msgs::srv::SetRoute_Response>::value
  >
{
};

template<>
struct is_service<ds_autonomy_msgs::srv::SetRoute>
  : std::true_type
{
};

template<>
struct is_service_request<ds_autonomy_msgs::srv::SetRoute_Request>
  : std::true_type
{
};

template<>
struct is_service_response<ds_autonomy_msgs::srv::SetRoute_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__SET_ROUTE__TRAITS_HPP_
