// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from ds_autonomy_msgs:srv/SetSpeedConstraints.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "ds_autonomy_msgs/srv/detail/set_speed_constraints__functions.h"
#include "ds_autonomy_msgs/srv/detail/set_speed_constraints__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace ds_autonomy_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void SetSpeedConstraints_Request_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) ds_autonomy_msgs::srv::SetSpeedConstraints_Request(_init);
}

void SetSpeedConstraints_Request_fini_function(void * message_memory)
{
  auto typed_message = static_cast<ds_autonomy_msgs::srv::SetSpeedConstraints_Request *>(message_memory);
  typed_message->~SetSpeedConstraints_Request();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember SetSpeedConstraints_Request_message_member_array[5] = {
  {
    "speed_limit",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Request, speed_limit),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "lateral_accel_limit",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Request, lateral_accel_limit),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "linear_accel",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Request, linear_accel),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "linear_decel",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Request, linear_decel),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "jerk_limit",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Request, jerk_limit),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers SetSpeedConstraints_Request_message_members = {
  "ds_autonomy_msgs::srv",  // message namespace
  "SetSpeedConstraints_Request",  // message name
  5,  // number of fields
  sizeof(ds_autonomy_msgs::srv::SetSpeedConstraints_Request),
  SetSpeedConstraints_Request_message_member_array,  // message members
  SetSpeedConstraints_Request_init_function,  // function to initialize message memory (memory has to be allocated)
  SetSpeedConstraints_Request_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t SetSpeedConstraints_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetSpeedConstraints_Request_message_members,
  get_message_typesupport_handle_function,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Request__get_type_hash,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Request__get_type_description,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Request__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace ds_autonomy_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>()
{
  return &::ds_autonomy_msgs::srv::rosidl_typesupport_introspection_cpp::SetSpeedConstraints_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ds_autonomy_msgs, srv, SetSpeedConstraints_Request)() {
  return &::ds_autonomy_msgs::srv::rosidl_typesupport_introspection_cpp::SetSpeedConstraints_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "ds_autonomy_msgs/srv/detail/set_speed_constraints__functions.h"
// already included above
// #include "ds_autonomy_msgs/srv/detail/set_speed_constraints__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace ds_autonomy_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void SetSpeedConstraints_Response_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) ds_autonomy_msgs::srv::SetSpeedConstraints_Response(_init);
}

void SetSpeedConstraints_Response_fini_function(void * message_memory)
{
  auto typed_message = static_cast<ds_autonomy_msgs::srv::SetSpeedConstraints_Response *>(message_memory);
  typed_message->~SetSpeedConstraints_Response();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember SetSpeedConstraints_Response_message_member_array[5] = {
  {
    "actual_speed_limit",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Response, actual_speed_limit),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "actual_lateral_accel_limit",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Response, actual_lateral_accel_limit),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "actual_linear_accel",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Response, actual_linear_accel),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "actual_linear_decel",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Response, actual_linear_decel),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "actual_jerk_limit",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Response, actual_jerk_limit),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers SetSpeedConstraints_Response_message_members = {
  "ds_autonomy_msgs::srv",  // message namespace
  "SetSpeedConstraints_Response",  // message name
  5,  // number of fields
  sizeof(ds_autonomy_msgs::srv::SetSpeedConstraints_Response),
  SetSpeedConstraints_Response_message_member_array,  // message members
  SetSpeedConstraints_Response_init_function,  // function to initialize message memory (memory has to be allocated)
  SetSpeedConstraints_Response_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t SetSpeedConstraints_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetSpeedConstraints_Response_message_members,
  get_message_typesupport_handle_function,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Response__get_type_hash,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Response__get_type_description,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Response__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace ds_autonomy_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>()
{
  return &::ds_autonomy_msgs::srv::rosidl_typesupport_introspection_cpp::SetSpeedConstraints_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ds_autonomy_msgs, srv, SetSpeedConstraints_Response)() {
  return &::ds_autonomy_msgs::srv::rosidl_typesupport_introspection_cpp::SetSpeedConstraints_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "ds_autonomy_msgs/srv/detail/set_speed_constraints__functions.h"
// already included above
// #include "ds_autonomy_msgs/srv/detail/set_speed_constraints__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace ds_autonomy_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void SetSpeedConstraints_Event_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) ds_autonomy_msgs::srv::SetSpeedConstraints_Event(_init);
}

void SetSpeedConstraints_Event_fini_function(void * message_memory)
{
  auto typed_message = static_cast<ds_autonomy_msgs::srv::SetSpeedConstraints_Event *>(message_memory);
  typed_message->~SetSpeedConstraints_Event();
}

size_t size_function__SetSpeedConstraints_Event__request(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Request> *>(untyped_member);
  return member->size();
}

const void * get_const_function__SetSpeedConstraints_Event__request(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Request> *>(untyped_member);
  return &member[index];
}

void * get_function__SetSpeedConstraints_Event__request(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Request> *>(untyped_member);
  return &member[index];
}

void fetch_function__SetSpeedConstraints_Event__request(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const ds_autonomy_msgs::srv::SetSpeedConstraints_Request *>(
    get_const_function__SetSpeedConstraints_Event__request(untyped_member, index));
  auto & value = *reinterpret_cast<ds_autonomy_msgs::srv::SetSpeedConstraints_Request *>(untyped_value);
  value = item;
}

void assign_function__SetSpeedConstraints_Event__request(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<ds_autonomy_msgs::srv::SetSpeedConstraints_Request *>(
    get_function__SetSpeedConstraints_Event__request(untyped_member, index));
  const auto & value = *reinterpret_cast<const ds_autonomy_msgs::srv::SetSpeedConstraints_Request *>(untyped_value);
  item = value;
}

void resize_function__SetSpeedConstraints_Event__request(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Request> *>(untyped_member);
  member->resize(size);
}

size_t size_function__SetSpeedConstraints_Event__response(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Response> *>(untyped_member);
  return member->size();
}

const void * get_const_function__SetSpeedConstraints_Event__response(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Response> *>(untyped_member);
  return &member[index];
}

void * get_function__SetSpeedConstraints_Event__response(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Response> *>(untyped_member);
  return &member[index];
}

void fetch_function__SetSpeedConstraints_Event__response(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const ds_autonomy_msgs::srv::SetSpeedConstraints_Response *>(
    get_const_function__SetSpeedConstraints_Event__response(untyped_member, index));
  auto & value = *reinterpret_cast<ds_autonomy_msgs::srv::SetSpeedConstraints_Response *>(untyped_value);
  value = item;
}

void assign_function__SetSpeedConstraints_Event__response(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<ds_autonomy_msgs::srv::SetSpeedConstraints_Response *>(
    get_function__SetSpeedConstraints_Event__response(untyped_member, index));
  const auto & value = *reinterpret_cast<const ds_autonomy_msgs::srv::SetSpeedConstraints_Response *>(untyped_value);
  item = value;
}

void resize_function__SetSpeedConstraints_Event__response(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<ds_autonomy_msgs::srv::SetSpeedConstraints_Response> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember SetSpeedConstraints_Event_message_member_array[3] = {
  {
    "info",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<service_msgs::msg::ServiceEventInfo>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Event, info),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "request",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>(),  // members of sub message
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Event, request),  // bytes offset in struct
    nullptr,  // default value
    size_function__SetSpeedConstraints_Event__request,  // size() function pointer
    get_const_function__SetSpeedConstraints_Event__request,  // get_const(index) function pointer
    get_function__SetSpeedConstraints_Event__request,  // get(index) function pointer
    fetch_function__SetSpeedConstraints_Event__request,  // fetch(index, &value) function pointer
    assign_function__SetSpeedConstraints_Event__request,  // assign(index, value) function pointer
    resize_function__SetSpeedConstraints_Event__request  // resize(index) function pointer
  },
  {
    "response",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>(),  // members of sub message
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(ds_autonomy_msgs::srv::SetSpeedConstraints_Event, response),  // bytes offset in struct
    nullptr,  // default value
    size_function__SetSpeedConstraints_Event__response,  // size() function pointer
    get_const_function__SetSpeedConstraints_Event__response,  // get_const(index) function pointer
    get_function__SetSpeedConstraints_Event__response,  // get(index) function pointer
    fetch_function__SetSpeedConstraints_Event__response,  // fetch(index, &value) function pointer
    assign_function__SetSpeedConstraints_Event__response,  // assign(index, value) function pointer
    resize_function__SetSpeedConstraints_Event__response  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers SetSpeedConstraints_Event_message_members = {
  "ds_autonomy_msgs::srv",  // message namespace
  "SetSpeedConstraints_Event",  // message name
  3,  // number of fields
  sizeof(ds_autonomy_msgs::srv::SetSpeedConstraints_Event),
  SetSpeedConstraints_Event_message_member_array,  // message members
  SetSpeedConstraints_Event_init_function,  // function to initialize message memory (memory has to be allocated)
  SetSpeedConstraints_Event_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t SetSpeedConstraints_Event_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetSpeedConstraints_Event_message_members,
  get_message_typesupport_handle_function,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Event__get_type_hash,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Event__get_type_description,
  &ds_autonomy_msgs__srv__SetSpeedConstraints_Event__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace ds_autonomy_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Event>()
{
  return &::ds_autonomy_msgs::srv::rosidl_typesupport_introspection_cpp::SetSpeedConstraints_Event_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ds_autonomy_msgs, srv, SetSpeedConstraints_Event)() {
  return &::ds_autonomy_msgs::srv::rosidl_typesupport_introspection_cpp::SetSpeedConstraints_Event_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "ds_autonomy_msgs/srv/detail/set_speed_constraints__functions.h"
// already included above
// #include "ds_autonomy_msgs/srv/detail/set_speed_constraints__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace ds_autonomy_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers SetSpeedConstraints_service_members = {
  "ds_autonomy_msgs::srv",  // service namespace
  "SetSpeedConstraints",  // service name
  // these two fields are initialized below on the first access
  // see get_service_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints>()
  nullptr,  // request message
  nullptr,  // response message
  nullptr,  // event message
};

static const rosidl_service_type_support_t SetSpeedConstraints_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetSpeedConstraints_service_members,
  get_service_typesupport_handle_function,
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints_Event>(),
  &::rosidl_typesupport_cpp::service_create_event_message<ds_autonomy_msgs::srv::SetSpeedConstraints>,
  &::rosidl_typesupport_cpp::service_destroy_event_message<ds_autonomy_msgs::srv::SetSpeedConstraints>,
  &ds_autonomy_msgs__srv__SetSpeedConstraints__get_type_hash,
  &ds_autonomy_msgs__srv__SetSpeedConstraints__get_type_description,
  &ds_autonomy_msgs__srv__SetSpeedConstraints__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace ds_autonomy_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::ds_autonomy_msgs::srv::rosidl_typesupport_introspection_cpp::SetSpeedConstraints_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure that both the request_members_ and the response_members_ are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr ||
    service_members->event_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::ds_autonomy_msgs::srv::SetSpeedConstraints_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::ds_autonomy_msgs::srv::SetSpeedConstraints_Response
      >()->data
      );

    // initialize the event_members_ with the static function from the external library
    service_members->event_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::ds_autonomy_msgs::srv::SetSpeedConstraints_Event
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ds_autonomy_msgs, srv, SetSpeedConstraints)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<ds_autonomy_msgs::srv::SetSpeedConstraints>();
}

#ifdef __cplusplus
}
#endif
