// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/BrakeReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'cmd_src'
#include "ds_dbw_msgs/msg/detail/cmd_src__struct.h"

/// Struct defined in msg/BrakeReport in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__BrakeReport
{
  std_msgs__msg__Header header;
  /// Options defined in BrakeCmd message
  uint8_t cmd_type;
  /// Pressure in bar
  float pressure_input;
  /// Pressure in bar
  float pressure_cmd;
  /// Pressure in bar
  float pressure_output;
  /// Torque in Nm
  float torque_input;
  /// Torque in Nm
  float torque_cmd;
  /// Torque in Nm
  float torque_output;
  /// Acceleration in m/s^2
  float accel_cmd;
  /// Acceleration in m/s^2
  float accel_output;
  /// Percent (0-100)
  float percent_input;
  /// Percent (0-100)
  float percent_cmd;
  /// Percent (0-100)
  float percent_output;
  bool btsi_cmd;
  bool limiting_value;
  bool limiting_rate;
  bool external_control;
  /// Status
  /// Ready to be enabled
  bool ready;
  /// Enabled
  bool enabled;
  /// Active override
  bool override_active;
  /// Override from other system
  bool override_other;
  /// Latched override
  bool override_latched;
  /// Command timeout (of valid messages)
  bool timeout;
  /// Fault of any kind
  bool fault;
  /// CRC error on most recent command
  bool bad_crc;
  /// Repeated rolling counter on most recent command
  bool bad_rc;
  /// Start of slower secondary report #####
  /// Degradation of any kind
  bool degraded;
  /// Calculated limit vs vehicle speed
  /// percent, bar, or m/s^2
  float limit_value;
  /// Brake available duration and actions
  float brake_available_duration;
  bool brake_available_full;
  bool req_shift_park;
  bool req_park_brake;
  /// Other braking sources
  bool external_button;
  bool comms_loss_armed;
  /// Command source
  ds_dbw_msgs__msg__CmdSrc cmd_src;
} ds_dbw_msgs__msg__BrakeReport;

// Struct for a sequence of ds_dbw_msgs__msg__BrakeReport.
typedef struct ds_dbw_msgs__msg__BrakeReport__Sequence
{
  ds_dbw_msgs__msg__BrakeReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__BrakeReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_
