// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/EcuInfo.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'name'
// Member 'version'
// Member 'mac_addr'
// Member 'config_hash'
// Member 'build_date'
// Member 'license_date'
// Member 'log_filename'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/EcuInfo in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__EcuInfo
{
  std_msgs__msg__Header header;
  /// Info
  /// OEM_PLATFORM_MODULE
  rosidl_runtime_c__String name;
  /// x.y.z
  rosidl_runtime_c__String version;
  /// XX:XX:XX:XX:XX:XX
  rosidl_runtime_c__String mac_addr;
  /// Config
  /// XXXXXXXX
  rosidl_runtime_c__String config_hash;
  uint8_t config_count_modified;
  uint8_t config_count_configured;
  bool config_nvm_blank;
  bool config_nvm_write_pending;
  /// License
  /// YYYY/MM/DD
  rosidl_runtime_c__String build_date;
  /// YYYY/MM/DD
  rosidl_runtime_c__String license_date;
  bool control_licensed;
  /// Logging
  /// XXXXXX.dbw
  rosidl_runtime_c__String log_filename;
  bool log_filesystem_present;
  bool log_fault;
} ds_dbw_msgs__msg__EcuInfo;

// Struct for a sequence of ds_dbw_msgs__msg__EcuInfo.
typedef struct ds_dbw_msgs__msg__EcuInfo__Sequence
{
  ds_dbw_msgs__msg__EcuInfo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__EcuInfo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__STRUCT_H_
