// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/ThrottleCmd.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CMD_NONE'.
/**
  * Command types
  * Command  Rate-limit  Range     Note
 */
enum
{
  ds_dbw_msgs__msg__ThrottleCmd__CMD_NONE = 0
};

/// Constant 'CMD_PEDAL_RAW'.
/**
  * %        %/s         0 to 100  Raw pedal sensor units
 */
enum
{
  ds_dbw_msgs__msg__ThrottleCmd__CMD_PEDAL_RAW = 13
};

/// Constant 'CMD_PERCENT'.
/**
  * %        %/s         0 to 100  Percent
 */
enum
{
  ds_dbw_msgs__msg__ThrottleCmd__CMD_PERCENT = 14
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/ThrottleCmd in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__ThrottleCmd
{
  std_msgs__msg__Header header;
  /// Brake command
  /// Command, changes with cmd_type
  float cmd;
  /// Rate limit for command increase, 0 for default, INFINITY for no limit, changes with cmd_type
  float rate_inc;
  /// Rate limit for command decrease, 0 for default, INFINITY for no limit, changes with cmd_type
  float rate_dec;
  uint8_t cmd_type;
  /// Enable
  bool enable;
  /// Clear latched overrides
  bool clear;
  /// Ignore future overrides
  bool ignore;
} ds_dbw_msgs__msg__ThrottleCmd;

// Struct for a sequence of ds_dbw_msgs__msg__ThrottleCmd.
typedef struct ds_dbw_msgs__msg__ThrottleCmd__Sequence
{
  ds_dbw_msgs__msg__ThrottleCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__ThrottleCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_H_
