// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/TurnSignalReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__TURN_SIGNAL_REPORT__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__TURN_SIGNAL_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'input'
// Member 'cmd'
// Member 'output'
// Member 'feedback'
#include "ds_dbw_msgs/msg/detail/turn_signal__struct.h"

/// Struct defined in msg/TurnSignalReport in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__TurnSignalReport
{
  std_msgs__msg__Header header;
  ds_dbw_msgs__msg__TurnSignal input;
  ds_dbw_msgs__msg__TurnSignal cmd;
  ds_dbw_msgs__msg__TurnSignal output;
  ds_dbw_msgs__msg__TurnSignal feedback;
  /// Status
  /// Ready to actuate command
  bool ready;
  /// Active override
  bool override_active;
  /// Override from other system
  bool override_other;
  /// Command timeout (of valid messages)
  bool timeout;
  /// CRC error on most recent command
  bool bad_crc;
  /// Repeated rolling counter on most recent command
  bool bad_rc;
  /// Degraded
  bool degraded;
  bool degraded_cmd_type;
  bool degraded_comms_dbw_steer;
  bool degraded_comms_dbw_brake;
  bool degraded_comms_dbw_thrtl;
  bool degraded_comms_vehicle;
  bool degraded_control_performance;
  /// Faults
  bool fault;
  bool fault_comms_vehicle;
} ds_dbw_msgs__msg__TurnSignalReport;

// Struct for a sequence of ds_dbw_msgs__msg__TurnSignalReport.
typedef struct ds_dbw_msgs__msg__TurnSignalReport__Sequence
{
  ds_dbw_msgs__msg__TurnSignalReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__TurnSignalReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__TURN_SIGNAL_REPORT__STRUCT_H_
