// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/UlcReport in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__UlcReport
{
  std_msgs__msg__Header header;
  /// ULC report
  /// Options defined in UlcCmd message
  uint8_t cmd_type;
  /// Reference velocity in m/s
  float vel_ref;
  /// Measured velocity in m/s
  float vel_meas;
  /// Reference acceleration in m/s^2
  float accel_ref;
  /// Measured acceleration in m/s^2
  float accel_meas;
  /// Echo of value in UlcCmd message
  bool coast_decel;
  /// Status
  /// Ready to be enabled
  bool ready;
  /// Enabled
  bool enabled;
  /// Active override
  bool override_active;
  /// Latched override
  bool override_latched;
  /// Preempted by other system
  bool preempted;
  /// Command timeout (of valid messages)
  bool timeout;
  /// CRC error on most recent command
  bool bad_crc;
  /// Repeated rolling counter on most recent command
  bool bad_rc;
} ds_dbw_msgs__msg__UlcReport;

// Struct for a sequence of ds_dbw_msgs__msg__UlcReport.
typedef struct ds_dbw_msgs__msg__UlcReport__Sequence
{
  ds_dbw_msgs__msg__UlcReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__UlcReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__ULC_REPORT__STRUCT_H_
