// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/VehicleVelocity.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__VEHICLE_VELOCITY__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__VEHICLE_VELOCITY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'DIR_NONE'.
/**
  * Direction unknown
 */
enum
{
  ds_dbw_msgs__msg__VehicleVelocity__DIR_NONE = 0
};

/// Constant 'DIR_PRNDL'.
/**
  * Transmission reverse gear sets negative direction
 */
enum
{
  ds_dbw_msgs__msg__VehicleVelocity__DIR_PRNDL = 1
};

/// Constant 'DIR_SENSOR'.
/**
  * Explicit wheel speed/direction sensors
 */
enum
{
  ds_dbw_msgs__msg__VehicleVelocity__DIR_SENSOR = 2
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/VehicleVelocity in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__VehicleVelocity
{
  std_msgs__msg__Header header;
  /// Vehicle velocities
  /// m/s, measured by brakes (wheel sensors)
  float vehicle_velocity_brake;
  /// m/s, measured by propulsion system
  float vehicle_velocity_propulsion;
  /// Source of direction
  uint8_t dir_src;
} ds_dbw_msgs__msg__VehicleVelocity;

// Struct for a sequence of ds_dbw_msgs__msg__VehicleVelocity.
typedef struct ds_dbw_msgs__msg__VehicleVelocity__Sequence
{
  ds_dbw_msgs__msg__VehicleVelocity * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__VehicleVelocity__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__VEHICLE_VELOCITY__STRUCT_H_
